加入收藏 | 设为首页 | 会员中心 | 我要投稿 李大同 (https://www.lidatong.com.cn/)- 科技、建站、经验、云计算、5G、大数据,站长网!
当前位置: 首页 > 站长学院 > PHP教程 > 正文

【Leetcode】Gas Station

发布时间:2020-12-13 21:09:07 所属栏目:PHP教程 来源:网络整理
导读:题目链接:https://leetcode.com/problems/gas-station/ 题目: There areNgas stations along a circular route,where the amount of gas at stationiis gas[i] . You have a car with an unlimited gas tank and it costs cost[i] of gas to travel from s

题目链接:https://leetcode.com/problems/gas-station/
题目:

There are N gas stations along a circular route,where the amount of gas at station i is gas[i].

You have a car with an unlimited gas tank and it costs cost[i] of gas to travel from station i to its next station (i+1). You begin the journey with an empty tank at one of the gas stations.

Return the starting gas station's index if you can travel around the circuit once,otherwise return ⑴.

Note:
The solution is guaranteed to be unique.

思路:

看了tag发现是贪心,想起老师上课说贪心实现起来是最简单的,最难的是证明贪心策略的正确性。这里主要为了AC,多尝试几次可能的策略懒得证明了(宝宝TM不会证明啊!!)。很自然想到的策略有:1、从gas最多的station开始 2、从cost最少的station开始 3、从剩余(gas-cost)最少的开始。

尝试了几次发现第2种是对的,但要注意如果有多个站点cost相同,要判断这些站点是不是能完成环圈旅行。

算法:

public int canCompleteCircuit(int[] gas,int[] cost) { int index = 0; for (int i = 1; i < cost.length; i++) { if (cost[i]<cost[index]) { index = i; } } for(int i=0;i<cost.length;i++){ if(cost[i]==cost[index]){ if(isValid(cost,gas,i)!=⑴){ return i; } } } return ⑴; } public int isValid(int[]cost,int[] gas,int index){ int tankGas = 0; for(int i=index;i<gas.length;i++){ tankGas+=gas[i]-cost[i]; if(tankGas<0){ return ⑴; } } for(int i=0;i<index;i++){ tankGas+=gas[i]-cost[i]; if(tankGas<0){ return ⑴; } } return index; }


(编辑:李大同)

【声明】本站内容均来自网络,其相关言论仅代表作者个人观点,不代表本站立场。若无意侵犯到您的权利,请及时与联系站长删除相关内容!

    推荐文章
      热点阅读